#include "cpu_conf.h"
#include "common.h"
#include "eeprom.h"

void pll_init (void)
{
	FLASH->ACR|= FLASH_ACR_PRFTBE;
	FLASH->ACR&=~FLASH_ACR_LATENCY;
	FLASH->ACR|= FLASH_ACR_LATENCY_0;
	//if(mul_value*f_ext_cr<=24)	FLASH->ACR|= FLASH_ACR_LATENCY_0;
	//if((mul_value*f_ext_cr>24)&(mul_value*f_ext_cr<=48))	FLASH->ACR|= FLASH_ACR_LATENCY_1;
	//if((mul_value*f_ext_cr>48)&(mul_value*f_ext_cr<=72))	FLASH->ACR|= FLASH_ACR_LATENCY_2;
		
	 // PLL 
	RCC->CFGR  &= ~RCC_CFGR_PLLSRC;        //   PLL  HSI    2
	RCC->CR   &= ~RCC_CR_PLLON;            //  PLL
	RCC->CFGR &= ~RCC_CFGR_PLLMULL;        // PLLMULL
	RCC->CFGR |=  RCC_CFGR_PLLMULL2;       //  = 2
	RCC->CR   |=  RCC_CR_PLLON;            //  PLL
	while((RCC->CR & RCC_CR_PLLRDY)==0) {} //  PLL

		//    PLL
	RCC->CFGR &= ~RCC_CFGR_SW;             //     
	RCC->CFGR |=  RCC_CFGR_SW_PLL;         //    PLL
	while((RCC->CFGR&RCC_CFGR_SWS)!=0x08){}//   PLL
		
	return;
}
void pio_config (void)
{
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN | RCC_APB2ENR_IOPCEN;	
	RCC->APB2ENR |= RCC_APB2ENR_IOPDEN | RCC_APB2ENR_IOPBEN;
	RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;
	
		
		// diagn
	GPIOA->CRL &= ~GPIO_CRL_MODE1;   
	GPIOA->CRL &= ~GPIO_CRL_CNF1_0;   
	GPIOA->CRL |= GPIO_CRL_CNF1_1;
	GPIOA->BSRR|= GPIO_BSRR_BR1;
	
	//adc_suppl
	GPIOB->CRL  &= ~(GPIO_CRL_MODE0 | GPIO_CRL_CNF0);  //GPIOB.0 - 
	
  // SIGNAL
	AFIO->MAPR|= AFIO_MAPR_TIM1_REMAP_PARTIALREMAP;
	GPIOA->CRL &= ~GPIO_CRL_MODE7;   //  MODE
	GPIOA->CRL &= ~GPIO_CRL_CNF7;    //  CNF
	GPIOA->CRL |=  GPIO_CRL_MODE7;   //, 50MHz
	GPIOA->CRL |=  GPIO_CRL_CNF7_1;  // , 
	
   //  1       left key
	GPIOA->CRL &= ~GPIO_CRL_MODE2;   //  MODE
	GPIOA->CRL &= ~GPIO_CRL_CNF2;    //  CNF
	GPIOA->CRL |= GPIO_CRL_CNF2_1;
	GPIOA->BSRR|= GPIO_BSRR_BS2;
					
   //  2      Center key
	GPIOA->CRL &= ~GPIO_CRL_MODE0;   //  MODE
	GPIOA->CRL &= ~GPIO_CRL_CNF0;    //  CNF
	GPIOA->CRL |= GPIO_CRL_CNF0_0;
	GPIOA->BSRR|= GPIO_BSRR_BR0;

	//  3     right key
	GPIOA->CRL &= ~GPIO_CRL_MODE5;   //  MODE
	GPIOA->CRL &= ~GPIO_CRL_CNF5;    //  CNF
	GPIOA->CRL |= GPIO_CRL_CNF5_1; 
	GPIOA->BSRR|= GPIO_BSRR_BS5;
	
		//  3     right key
	GPIOA->CRL &= ~GPIO_CRL_MODE3;   //  MODE
	GPIOA->CRL &= ~GPIO_CRL_CNF3;    //  CNF
	GPIOA->CRL |= GPIO_CRL_CNF3_1; 
	GPIOA->BSRR|= GPIO_BSRR_BS3;
	
	
		// LV Pin
	GPIOB->CRL |= GPIO_CRL_MODE0;   
	GPIOB->CRL &= ~GPIO_CRL_CNF0;
	GPIOB->BSRR|= GPIO_BSRR_BR0;
	

		// TEST Pin
	GPIOA->CRL |= GPIO_CRL_MODE5;   
	GPIOA->CRL &= ~GPIO_CRL_CNF5;
	GPIOA->BSRR|=  GPIO_BSRR_BR5;
	
	//sound
	GPIOB->CRL &= ~GPIO_CRL_MODE6;   //???????? ??????? MODE
	GPIOB->CRL &= ~GPIO_CRL_CNF6;    //???????? ??????? CNF
	GPIOB->CRL |=  GPIO_CRL_MODE6;   //?????, 50MHz
	GPIOB->CRL |=  GPIO_CRL_CNF6_1;  //?????????????? ???????, ???????????
	
	
	GPIOB->CRH |= GPIO_CRH_MODE9;   
	GPIOB->CRH &= ~GPIO_CRH_CNF9;
	GPIOB->BSRR|= GPIO_BSRR_BR9;
	


}
void SPI2_init (void)
{
	//AFIO->MAPR |=AFIO_MAPR_SPI1_REMAP ;
	
	//  MOSI PB15:    , 50 MHz
	GPIOB->CRH   |=  GPIO_CRH_MODE15;    //
  GPIOB->CRH   &= ~GPIO_CRH_CNF15;     //
  GPIOB->CRH   |=  GPIO_CRH_CNF15_1;   //
 
	// MISO PB14:     , 50MHz
  GPIOB->CRH   &= ~GPIO_CRH_MODE14;    //
  GPIOB->CRH   &= ~GPIO_CRH_CNF14;     //
  GPIOB->CRH   |=  GPIO_CRH_CNF14_1;   //
//  GPIOB->BSRR   =  GPIO_BSRR_BR14;     //
	
 
  // SCK PB13:     , 50MHz
  GPIOB->CRH   |=  GPIO_CRH_MODE13;    //
  GPIOB->CRH   &= ~GPIO_CRH_CNF13;     //
  GPIOB->CRH   |=  GPIO_CRH_CNF13_1;   //
 
  // NSS PB12:     , 50MHz
	GPIOB->CRH |= GPIO_CRH_MODE12;  
	GPIOB->CRH &=~GPIO_CRH_CNF12;
	GPIOB->BSRR|= GPIO_BSRR_BS12;
 
  //  SPI
  RCC->APB1ENR |= RCC_APB1ENR_SPI2EN; // 
  SPI2->CR2     = 0x0000;             //
  SPI2->CR1     = SPI_CR1_MSTR;       // -  
	
	SPI2->CR1    &= ~SPI_CR1_CPHA;
	SPI2->CR1    &= ~SPI_CR1_CPOL; 
	SPI2->CR1    &= ~SPI_CR1_RXONLY;		//  
	SPI2->CR1    &= ~SPI_CR1_DFF;				//   8 
	
  SPI2->CR1    |= SPI_CR1_BR;         //   
	
	/*
	SPI2->CR1 &= ~SPI_CR1_BR_0;
	SPI2->CR1 &= ~SPI_CR1_BR_1;
	SPI2->CR1 &= ~SPI_CR1_BR_2;
	*/
	
  SPI2->CR1    |= SPI_CR1_SSI;
  SPI2->CR1    |= SPI_CR1_SSM;				//  NSS
  SPI2->CR1    |= SPI_CR1_SPE;        //  SPI
	
	return;
}

uint8_t spi_send (uint8_t data)
{ 
  while (!(SPI2->SR & SPI_SR_TXE));      //  
  SPI2->DR = data;                       //   
  while (!(SPI2->SR & SPI_SR_RXNE));     //  
  return (SPI2->DR);		        				 //  
}

uint8_t spi_read (void)
{ 
  return spi_send(0xff);		  //  
}




void sys_tick_config (void)	// ????????? 50 ??
{
	SysTick->CTRL|=SysTick_CTRL_ENABLE;
	SysTick->CTRL|=SysTick_CTRL_TICKINT; 
	//SysTick->CTRL|=SysTick_CTRL_CLKSOURCE;//f_clk
	SysTick->CTRL&=~SysTick_CTRL_CLKSOURCE;//f_clk/8
	SysTick->VAL   = 0; 
	
	SysTick->LOAD=20000; //50??
	
	//NVIC_EnableIRQ(SysTick_IRQn );
	NVIC_SetPriority(SysTick_IRQn,3);
	return;
}

void T4_config (void)  
{
	RCC->APB1ENR |=RCC_APB1ENR_TIM4EN;

	TIM4->PSC = 8-1;
	TIM4->ARR = 1000; 
	TIM4->CCR1 = 100;
	
	TIM4->CCMR1 = TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1PE;
	TIM4->CCER = TIM_CCER_CC1E;
	TIM4->BDTR = TIM_BDTR_MOE;
	//TIM4->DIER |= TIM_DIER_UIE;
	//TIM4->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;	
	NVIC_SetPriority(TIM4_IRQn , 5);
	NVIC_EnableIRQ(TIM4_IRQn);
				    
	return;
}
unsigned int play_snd (unsigned int fr_hz, unsigned int time_ms)
{
	unsigned int time=0;
	TIM4->ARR = fr_hz; 
	TIM4->CCR1 = TIM4->ARR/4;
	time=time_ms;
	TIM4->DIER |= TIM_DIER_UIE;
	TIM4->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;	
	return (time);
}

void T3_config (void)  //  50 
{
	RCC->APB1ENR |=RCC_APB1ENR_TIM3EN;

	TIM3->PSC = 160-1;
	TIM3->ARR = 1000; 

//	TIM3->CCR2 = 10;
//	TIM3->CCMR1 = TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1 | TIM_CCMR1_OC2PE;
//	TIM3->CCER = TIM_CCER_CC2E;
	//TIM3->BDTR = TIM_BDTR_MOE;
	
	TIM3->DIER |= TIM_DIER_UIE;
	
	TIM3->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;		
	

	NVIC_SetPriority(TIM3_IRQn , 4);
	NVIC_EnableIRQ(TIM3_IRQn);
				    
	return;
}

void T2_capt_init(void)
{
	// pin capt assign to TIM2_ch2
	GPIOA->CRL &= ~GPIO_CRL_MODE1;   
	GPIOA->CRL |= GPIO_CRL_CNF1_0;
	GPIOA->CRL &= ~GPIO_CRL_CNF1_1;

	RCC->APB1ENR |=RCC_APB1ENR_TIM2EN;// Timer Capt

	//TIM2->PSC = 24-1;
	TIM2->PSC = 8-1;
	TIM2->ARR = 0xffff;

	TIM2->CCMR1&=~TIM_CCMR1_CC1S_0;TIM2->CCMR1|=TIM_CCMR1_CC1S_1;// connect	 IC2 to TI1
	TIM2->CCER&=~TIM_CCER_CC1P;	// capture on rising edge 

	TIM2->CCMR1&=~TIM_CCMR1_CC2S_1;TIM2->CCMR1|=TIM_CCMR1_CC2S_0;// connect	 IC2 to TI2
	TIM2->CCER|=TIM_CCER_CC2P;	// capture on falling edge 

	TIM2->SMCR|= TIM_SMCR_TS_2 | TIM_SMCR_TS_1;	
	TIM2->SMCR&= ~TIM_SMCR_TS_0;
		
	TIM2->SMCR|= TIM_SMCR_SMS_2; // Reset mode
	TIM2->SMCR&= ~TIM_SMCR_SMS_1;
	TIM2->SMCR&= ~TIM_SMCR_SMS_0;
	
	TIM2->CCER|= TIM_CCER_CC1E | TIM_CCER_CC2E;
	
	TIM2->DIER=0;
	TIM2->CR1=0;
	//TIM2->DIER |= TIM_DIER_CC2IE;TIM2->DIER |= TIM_DIER_CC1IE;
 // TIM2->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;		
	
	NVIC_SetPriority(TIM2_IRQn , 1);
	NVIC_EnableIRQ(TIM2_IRQn);
	return;
}


void T1_config(void)
{
	RCC->APB2ENR |=RCC_APB2ENR_TIM1EN; 

	TIM1->PSC = 8-1; //    1
	TIM1->ARR = 0xffff;
	
	TIM1->CCR1 = 1*100;
	
	TIM1->CCMR1 = TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1PE;
	TIM1->CCER = TIM_CCER_CC1NE;
	TIM1->BDTR = TIM_BDTR_MOE;
		
	TIM1->CR1 = TIM_CR1_OPM;
	TIM1->CR1 = TIM_CR1_DIR;

	TIM1->DIER |= TIM_DIER_UIE;	
	TIM1->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;	

	
	NVIC_SetPriority(TIM1_UP_TIM16_IRQn  , 2);
	NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn );
	
	return;
}
void RTC_conf (void)
{
	RCC->APB1ENR |= RCC_APB1ENR_PWREN ;
//	RCC->APB1ENR |= RCC_APB1ENR_BKPEN;

	PWR->CR |= PWR_CR_DBP;		  /*!< Disable Backup Domain write protection */

	RCC->BDCR|= RCC_BDCR_RTCEN;	   /*!< RTC clock enable */

	RCC->BDCR |= RCC_BDCR_BDRST;   /*!< Backup domain software reset  */
	RCC->BDCR &= ~RCC_BDCR_BDRST;

	RCC->BDCR |= RCC_BDCR_RTCEN | RCC_BDCR_RTCSEL_LSI;		 /*!< LSI oscillator clock used as RTC clock */

	RTC->CRL |= RTC_CRL_CNF;	   /*!<Configuration Flag */
//	RTC->PRLL = 0x7FFF;
	RTC->PRLL = 0x9c3f;

	RTC->CNTH = 0;
	RTC->CNTL = 0;
	RTC->CRL &= ~RTC_CRL_CNF;

	RTC->CRH|=RTC_CRH_SECIE;   /*!<Second Interrupt Enable */

	RCC->CSR |= RCC_CSR_LSION;
	while ((RCC->CSR & RCC_CSR_LSION) != RCC_CSR_LSION){}

//	RTC->CRL &= (uint16_t)~RTC_CRL_RSF;
//	while((RTC->CRL & RTC_CRL_RSF) != RTC_CRL_RSF){}
	return;
}

void RTC_refr_par (void)
{
	RTC->CRL |= RTC_CRL_CNF;	   /*!<Configuration Flag */
	RTC->PRLL = 0xa40f;
	RTC->CNTH = 0;
	RTC->CNTL = 0;
	RTC->CRL &= ~RTC_CRL_CNF;
	RTC->CRH|=RTC_CRH_SECIE;   /*!<Second Interrupt Enable */
	return;
}
__asm void wfe (void)
{
	WFE
}
__asm void wfi (void)
{
	WFI
}

void power_save_mode (void)
{
	PWR->CSR|=	PWR_CSR_EWUP;

	PWR->CR|= PWR_CR_CSBF ;
	PWR->CR|= PWR_CR_CWUF;
	
	SCB->SCR|= SCB_SCR_SLEEPDEEP;
	PWR->CR|= PWR_CR_PDDS;
	
	wfi ();
	//wfe ();
	return;
}

void exti_capt (void)
{
	AFIO->EXTICR [1>>0x02] |= AFIO_EXTICR1_EXTI1_PA;
	EXTI->IMR |= EXTI_IMR_MR1;		
	EXTI->RTSR |= 	EXTI_RTSR_TR1; 
	EXTI->FTSR |= 	EXTI_FTSR_TR1; 
	NVIC_EnableIRQ (EXTI1_IRQn);
	NVIC_SetPriority(EXTI1_IRQn, 3);
	return;
}
void adc_init (void)
{
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN;
	//     
	RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;                //  GPIOB
	GPIOA->CRL  &= ~(GPIO_CRL_MODE2 | GPIO_CRL_CNF2);  //GPIOA.2 -  2
	//     
	ADC1->JSQR   =   0;                                //    1 
	ADC1->JSQR  |=   2<<15;                            // 1 -  2
	//  
	ADC1->CR1    =   0;                                //   
	ADC1->CR2    =   0;                                //   
	ADC1->CR2   |=   7<<12;                            //   - JSWSTART 
	ADC1->CR2   |=   ADC_CR2_JEXTTRIG;                 //  
	 
	//    
	ADC1->CR2   |=   ADC_CR2_ADON;                     // 
	ADC1->CR2   |=   ADC_CR2_RSTCAL;                   //  
//	while(!(ADC1->CR2 & ADC_CR2_RSTCAL)){};            //  
	ADC1->CR2   |=   ADC_CR2_CAL;                      //  
	//while(!(ADC1->CR2 & ADC_CR2_CAL)){};               //  
	 
	ADC1->CR2   |=   ADC_CR2_JSWSTART;                 //  .

	return;
}

void USART1_Init(void)
{
  // 
  RCC->APB2ENR |=   RCC_APB2ENR_IOPAEN;                // GPIO
  RCC->APB2ENR |=   RCC_APB2ENR_AFIOEN;                //   GPIO
  RCC->APB2ENR |=   RCC_APB2ENR_USART1EN;              // USART1
  // PORTA.9  TX; PORTA.10  RX 
  GPIOA->CRH   &= ~(GPIO_CRH_MODE9 | GPIO_CRH_CNF9);   // MODE  CNF
  GPIOA->CRH   |=   GPIO_CRH_MODE9 | GPIO_CRH_CNF9_1;  //    -, 50MHz
  GPIOA->CRH   &= ~(GPIO_CRH_MODE10 | GPIO_CRH_CNF10); // MODE  CNF
  GPIOA->CRH   |=   GPIO_CRH_CNF10_0;                  //,  
  //  
 //  USART1->BRR   =   0x0D05;                            //C  2400 
	USART1->BRR   =   0x0683;                            //C  4800 
//	USART1->BRR   =   0x008B;                            //C  57600 
	USART1->BRR   =   0x0341;                            //C  9600 
  USART1->CR1  &=  ~USART_CR1_M;                       //8  
  USART1->CR2  &=  ~USART_CR2_STOP;                    //  -
  USART1->CR2  |=   USART_CR2_STOP_0;                  // -: 2
  // 
  USART1->CR1  |=   USART_CR1_UE;                      //  USART1
  USART1->CR1  |=   USART_CR1_TE;                      // 
  USART1->CR1  |=   USART_CR1_RE;                      // 
	 USART1->CR1  |= USART_CR1_RXNEIE;                    //   
  // 
  NVIC_EnableIRQ (USART1_IRQn);                        // USART1
	NVIC_SetPriority(USART1_IRQn  , 1);
}
 
void USART1_SendData(unsigned char data)
{
  USART1->DR  =  data;                                //????????? ??????? ????????
  while((USART1->SR & USART_SR_TC)==0) {}             //???????? ???????? ?????
  USART1->SR &=  ~USART_SR_TC;                        //???????? ????
		return;
}



void USART2_Init(void)
{
  // 
  RCC->APB2ENR |=   RCC_APB2ENR_IOPAEN;                // GPIO
  RCC->APB2ENR |=   RCC_APB2ENR_AFIOEN;                //   GPIO
  RCC->APB1ENR |=   RCC_APB1ENR_USART2EN;              // USART2
  // PORTA.2  TX; PORTA.3  RX 
  GPIOA->CRL   &= ~(GPIO_CRL_MODE2 | GPIO_CRL_CNF2);   // MODE  CNF
  GPIOA->CRL   |=   GPIO_CRL_MODE2 | GPIO_CRL_CNF2_1;  //    -, 50MHz
  GPIOA->CRL   &= ~(GPIO_CRL_MODE3 | GPIO_CRL_CNF3);   // MODE  CNF
  GPIOA->CRL   |=   GPIO_CRL_CNF3_0;                   //,  
  //  
 // USART2->BRR   =   0x0341;                            //C  9600 
	
 // USART2->BRR   =   0x0D05;                            //C  2400 
	
//	USART2->BRR   =   0x0683;                            //C  4800 
//	USART2->BRR   =   0x008B;                            //C  57600 
	USART2->BRR   =   0x0D05;                            //C  2400 
  USART2->CR1  &=  ~USART_CR1_M;                       //8  
  USART2->CR2  &=  ~USART_CR2_STOP;                    //  -
  USART2->CR2  |=   USART_CR2_STOP_0;                  // -: 2
  // 
  USART2->CR1  |=   USART_CR1_UE;                      //  USART2
  USART2->CR1  |=   USART_CR1_TE;                      // 
  USART2->CR1  |=   USART_CR1_RE;                      // 
	USART2->CR1  |= USART_CR1_RXNEIE;                    //   
	  // 
  NVIC_EnableIRQ (USART2_IRQn);                        // USART1
	NVIC_SetPriority(USART2_IRQn  , 1);
}
//********************************************************************************
//Function: USART2 -                                               //
//Argument:                                                     //
//********************************************************************************
void USART2_SendData(unsigned char data)
{
  USART2->DR  =  data;                                //  
  while((USART2->SR & USART_SR_TC)==0) {}             //  
  USART2->SR &=  ~USART_SR_TC;                        // 
}
