#include "stm32F10x.h"

#define volt_33	3300


//#define right_key			GPIO_IDR_IDR2	  // PORTA
#define right_key			GPIO_IDR_IDR3	  // PORTA
#define left_key			GPIO_IDR_IDR2	  // PORTA
#define center_key		GPIO_IDR_IDR0	  // PORTA

//     3.3 
#define LV_on  				GPIOB->BSRR|= GPIO_BSRR_BR0;
#define LV_off  			GPIOB->BSRR|= GPIO_BSRR_BS0;

#define HV_ON					GPIOB->BSRR|= GPIO_BSRR_BS9;
#define HV_OFF					GPIOB->BSRR|= GPIO_BSRR_BR9;

// 
#define led_x1_high			GPIOB->BSRR|= GPIO_BSRR_BS13; 
#define led_x2_high			GPIOB->BSRR|= GPIO_BSRR_BS12; 
#define led_x3_high			GPIOB->BSRR|= GPIO_BSRR_BS10; 
#define led_x4_high			GPIOB->BSRR|= GPIO_BSRR_BS11; 
#define led_x5_high			GPIOB->BSRR|= GPIO_BSRR_BS14; 

#define led_x1_low			GPIOB->BSRR|= GPIO_BSRR_BR13; 
#define led_x2_low			GPIOB->BSRR|= GPIO_BSRR_BR12; 
#define led_x3_low			GPIOB->BSRR|= GPIO_BSRR_BR10;
#define led_x4_low			GPIOB->BSRR|= GPIO_BSRR_BR11; 
#define led_x5_low			GPIOB->BSRR|= GPIO_BSRR_BR14; 

#define led_y1_high			GPIOB->BSRR|= GPIO_BSRR_BS9; 
#define led_y2_high			GPIOA->BSRR|= GPIO_BSRR_BS8; 
#define led_y3_high			GPIOA->BSRR|= GPIO_BSRR_BS12; 
#define led_y4_high			GPIOB->BSRR|= GPIO_BSRR_BS8; 
#define led_y5_high			GPIOB->BSRR|= GPIO_BSRR_BS5; 

#define led_y1_low			GPIOB->BSRR|= GPIO_BSRR_BR9; 
#define led_y2_low			GPIOA->BSRR|= GPIO_BSRR_BR8; 
#define led_y3_low			GPIOA->BSRR|= GPIO_BSRR_BR12; 
#define led_y4_low			GPIOB->BSRR|= GPIO_BSRR_BR8; 
#define led_y5_low			GPIOB->BSRR|= GPIO_BSRR_BR5; 

#define capt_start 			TIM2->DIER=0; TIM2->DIER |= TIM_DIER_CC1IE; TIM2->CR1|= TIM_CR1_CEN ;	

#define capt_halt 			TIM2->DIER =0; TIM2->CR1 = 0;

#define PWM_halt	TIM1->CR1 &= ~TIM_CR1_CEN; 
#define PWM_start	TIM1->CR1 |= TIM_CR1_CEN;

void pll_init (void);
void pio_config (void);
void sys_tick_config (void);
void T1_config (void);
void T2_config (void);
void T3_config (void);
void T4_config (void);

void RTC_conf (void);
void RTC_refr_par (void);

void exti_capt (void);
void T2_capt_init(void);
void adc_init (void);
void USART1_Init(void);
void USART1_SendData(unsigned char data);
void UART1_send_val_3(unsigned int data);
void USART2_Init(void);
void USART2_SendData(unsigned char data);
void SPI2_init (void);

__asm void wfe (void);
__asm void wfi (void);
void power_save_mode (void);

unsigned int play_snd (unsigned int fr_hz, unsigned int time_ms);






