#include "cpu_conf.h"
#include "common.h"
#include "eeprom.h"

void pll_init (void)
{
	FLASH->ACR|= FLASH_ACR_PRFTBE;
	FLASH->ACR&=~FLASH_ACR_LATENCY;
	FLASH->ACR|= FLASH_ACR_LATENCY_0;
	//if(mul_value*f_ext_cr<=24)	FLASH->ACR|= FLASH_ACR_LATENCY_0;
	//if((mul_value*f_ext_cr>24)&(mul_value*f_ext_cr<=48))	FLASH->ACR|= FLASH_ACR_LATENCY_1;
	//if((mul_value*f_ext_cr>48)&(mul_value*f_ext_cr<=72))	FLASH->ACR|= FLASH_ACR_LATENCY_2;
		
  // PLL 
  RCC->CFGR  &= ~RCC_CFGR_PLLSRC;        //   PLL  HSI    2
  RCC->CR   &= ~RCC_CR_PLLON;            //  PLL
  RCC->CFGR &= ~RCC_CFGR_PLLMULL;        // PLLMULL
  RCC->CFGR |=  RCC_CFGR_PLLMULL2;       //  = 2
  RCC->CR   |=  RCC_CR_PLLON;            //  PLL
  while((RCC->CR & RCC_CR_PLLRDY)==0) {} //  PLL

  //    PLL
  RCC->CFGR &= ~RCC_CFGR_SW;             //     
  RCC->CFGR |=  RCC_CFGR_SW_PLL;         //    PLL
  while((RCC->CFGR&RCC_CFGR_SWS)!=0x08){}//   PLL
		
	return;
}
void pio_config (void)
{
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN | RCC_APB2ENR_IOPCEN;	
	RCC->APB2ENR |= RCC_APB2ENR_IOPDEN | RCC_APB2ENR_IOPBEN;
	RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;
	
	AFIO->MAPR|=AFIO_MAPR_SWJ_CFG_JTAGDISABLE;
	
	// lcd 
	//D7
	GPIOB->CRH |= GPIO_CRH_MODE15;  
	GPIOB->CRH &= ~GPIO_CRH_CNF15;
	GPIOB->BSRR|= GPIO_BSRR_BR15;
	//D6
	GPIOB->CRH |= GPIO_CRH_MODE14;  
	GPIOB->CRH &= ~GPIO_CRH_CNF14;
	GPIOB->BSRR|= GPIO_BSRR_BR14;
	//D5
	GPIOB->CRH |= GPIO_CRH_MODE13;  
	GPIOB->CRH &= ~GPIO_CRH_CNF13;
	GPIOB->BSRR|= GPIO_BSRR_BR13;
	//D4
	GPIOB->CRH |= GPIO_CRH_MODE12;  
	GPIOB->CRH &= ~GPIO_CRH_CNF12;
	GPIOB->BSRR|= GPIO_BSRR_BR12;
	//D3
	GPIOB->CRH |= GPIO_CRH_MODE11;  
	GPIOB->CRH &= ~GPIO_CRH_CNF11;
	GPIOB->BSRR|= GPIO_BSRR_BR11;
	//D2
	GPIOB->CRH |= GPIO_CRH_MODE10;  
	GPIOB->CRH &= ~GPIO_CRH_CNF10;
	GPIOB->BSRR|= GPIO_BSRR_BR10;
	//D1
	GPIOB->CRH |= GPIO_CRH_MODE9;  
	GPIOB->CRH &= ~GPIO_CRH_CNF9;
	GPIOB->BSRR|= GPIO_BSRR_BR9;
	//D0
	GPIOB->CRH |= GPIO_CRH_MODE8;  
	GPIOB->CRH &= ~GPIO_CRH_CNF8;
	GPIOB->BSRR|= GPIO_BSRR_BR8;
	
	//RD
	GPIOA->CRH |= GPIO_CRH_MODE8;  
	GPIOA->CRH &= ~GPIO_CRH_CNF8;
	GPIOA->BSRR|= GPIO_BSRR_BS8;
	//WR
	GPIOA->CRH |= GPIO_CRH_MODE9;  
	GPIOA->CRH &= ~GPIO_CRH_CNF9;
	GPIOA->BSRR|= GPIO_BSRR_BS9;
	//RS
	GPIOA->CRH |= GPIO_CRH_MODE10;  
	GPIOA->CRH &= ~GPIO_CRH_CNF10;
	GPIOA->BSRR|= GPIO_BSRR_BS10;
	//RST
	GPIOA->CRH |= GPIO_CRH_MODE11;  
	GPIOA->CRH &= ~GPIO_CRH_CNF11;
	GPIOA->BSRR|= GPIO_BSRR_BS11;
	//CS
	GPIOA->CRH |= GPIO_CRH_MODE12;  
	GPIOA->CRH &= ~GPIO_CRH_CNF12;
	GPIOA->BSRR|= GPIO_BSRR_BS12;
	
	GPIOB->CRL |= GPIO_CRL_MODE5;  
	GPIOB->CRL &= ~GPIO_CRL_CNF5;
	GPIOB->BSRR|= GPIO_BSRR_BS5;
	
	// CENTER key
	GPIOA->CRL &=~GPIO_CRL_MODE0;
	GPIOA->CRL &=~GPIO_CRL_CNF0_0;
	GPIOA->CRL |= GPIO_CRL_CNF0_1;
	GPIOA->BSRR|= GPIO_BSRR_BR0;
	
	// right key
	GPIOA->CRH &=~GPIO_CRH_MODE15;
	GPIOA->CRH &=~GPIO_CRH_CNF15_0;
	GPIOA->CRH |= GPIO_CRH_CNF15_1;
	GPIOA->BSRR|= GPIO_BSRR_BS15;
	
	GPIOB->CRL &=~GPIO_CRL_MODE7;
	GPIOB->CRL &=~GPIO_CRL_CNF7_0;
	GPIOB->CRL |= GPIO_CRL_CNF7_1;
	GPIOB->BSRR|= GPIO_BSRR_BS7;
	
	GPIOB->CRL |= GPIO_CRL_MODE5;  
	GPIOB->CRL &= ~GPIO_CRL_CNF5;
	GPIOB->BSRR|= GPIO_BSRR_BS5;
	
		//sound
	GPIOB->CRL &= ~GPIO_CRL_MODE6;  
	GPIOB->CRL &= ~GPIO_CRL_CNF6;
	GPIOB->CRL |=  GPIO_CRL_MODE6_1;
	GPIOB->CRL &= ~GPIO_CRL_CNF6;  
	GPIOB->BSRR =  GPIO_BSRR_BR6;  
	
	
	GPIOA->CRL |= GPIO_CRL_MODE3;  
	GPIOA->CRL &= ~GPIO_CRL_CNF3;
	GPIOA->BSRR|= GPIO_BSRR_BR3;
	

	
	GPIOA->CRL |= GPIO_CRL_MODE1;  
	GPIOA->CRL &= ~GPIO_CRL_CNF1;
	GPIOA->BSRR|= GPIO_BSRR_BR1;
	
	GPIOB->CRL &=~GPIO_CRL_MODE1;
	GPIOB->CRL &=~GPIO_CRL_CNF1_0;
	GPIOB->CRL |= GPIO_CRL_CNF1_1;
	GPIOB->BSRR|= GPIO_BSRR_BR1;
	
	return;
}

void T4_config (void)  
{
	RCC->APB1ENR |=RCC_APB1ENR_TIM4EN;

	TIM4->PSC = 4-1;
//	TIM4->PSC = 16-1;
	TIM4->ARR = 10000; 
	TIM4->CCR1 = 1000;
	
	TIM4->CCMR1 = TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1PE;
	TIM4->CCER = TIM_CCER_CC1E;
	TIM4->BDTR = TIM_BDTR_MOE;
	//TIM4->DIER |= TIM_DIER_UIE;
	//TIM4->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;	
	NVIC_SetPriority(TIM4_IRQn , 4);
	NVIC_EnableIRQ(TIM4_IRQn);
				    
	return;
}
unsigned int play_snd (unsigned int fr_hz, unsigned int time_ms)
{
	unsigned int time=0;
	snd_pin_en;
	TIM4->ARR = fr_hz; 
	TIM4->CCR1 = TIM4->ARR/2;
	time=time_ms;
	TIM4->DIER |= TIM_DIER_UIE;
	TIM4->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;	
	return (time);
}
void T3_config (void)  
{
//RCC->APB1ENR |=RCC_APB1ENR_TIM3EN;

	//TIM3->PSC = 160-1;
	TIM3->PSC = 320-1;
	TIM3->ARR = 1000; 

//	TIM3->CCR2 = 10;
//	TIM3->CCMR1 = TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1 | TIM_CCMR1_OC2PE;
//	TIM3->CCER = TIM_CCER_CC2E;
	//TIM3->BDTR = TIM_BDTR_MOE;
	
	TIM3->DIER |= TIM_DIER_UIE;
	
	TIM3->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;		
	

	NVIC_SetPriority(TIM3_IRQn , 5);
	NVIC_EnableIRQ(TIM3_IRQn);
				    
	return;
}

void sys_tick_config (void)	//  50 
{
	SysTick->CTRL|=SysTick_CTRL_ENABLE;
	SysTick->CTRL|=SysTick_CTRL_TICKINT; 
	//SysTick->CTRL|=SysTick_CTRL_CLKSOURCE;//f_clk
	SysTick->CTRL&=~SysTick_CTRL_CLKSOURCE;//f_clk/8
	SysTick->VAL   = 0; 
	
	SysTick->LOAD=10000; //200
	
	//NVIC_EnableIRQ(SysTick_IRQn );
	NVIC_SetPriority(SysTick_IRQn,3);
	return;
}
/*
void T2_capt_init(void)
{
	// pin capt assign to TIM2_ch2
	GPIOA->CRL &= ~GPIO_CRL_MODE1;   
	GPIOA->CRL |= GPIO_CRL_CNF1_0;
	GPIOA->CRL &= ~GPIO_CRL_CNF1_1;

	RCC->APB1ENR |=RCC_APB1ENR_TIM2EN;// Timer Capt

	//TIM2->PSC = 8-1;
	TIM2->PSC = 16-1;
	TIM2->ARR = 0xffff;

	TIM2->CCMR1&=~TIM_CCMR1_CC1S_0;TIM2->CCMR1|=TIM_CCMR1_CC1S_1;// connect	 IC2 to TI1
	TIM2->CCER&=~TIM_CCER_CC1P;	// capture on rising edge 

	TIM2->CCMR1&=~TIM_CCMR1_CC2S_1;TIM2->CCMR1|=TIM_CCMR1_CC2S_0;// connect	 IC2 to TI2
	TIM2->CCER|=TIM_CCER_CC2P;	// capture on falling edge 

	TIM2->SMCR|= TIM_SMCR_TS_2 | TIM_SMCR_TS_1;	
	TIM2->SMCR&= ~TIM_SMCR_TS_0;
		
	TIM2->SMCR|= TIM_SMCR_SMS_2; // Reset mode
	TIM2->SMCR&= ~TIM_SMCR_SMS_1;
	TIM2->SMCR&= ~TIM_SMCR_SMS_0;
	
	TIM2->CCER|= TIM_CCER_CC1E | TIM_CCER_CC2E;
	
	TIM2->DIER=0;
	TIM2->CR1=0;
	//TIM2->DIER |= TIM_DIER_CC2IE;TIM2->DIER |= TIM_DIER_CC1IE;
 // TIM2->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;		
	
	NVIC_SetPriority(TIM2_IRQn , 1);
	NVIC_EnableIRQ(TIM2_IRQn);
	return;
}
*/
void T2_config (void)  
{
	// ************ **********************************
	RCC->APB1ENR |=RCC_APB1ENR_TIM2EN; //  
	
	GPIOA->CRL &= ~GPIO_CRL_MODE2;   //  MODE
	GPIOA->CRL &= ~GPIO_CRL_CNF2;    //  CNF
	GPIOA->CRL |=  GPIO_CRL_MODE2;   //, 50MHz
	GPIOA->CRL |=  GPIO_CRL_CNF2_1;  // , 

	//  
	TIM2->PSC = 0x08;
	//   
	TIM2->ARR = 0xff;
	TIM2->CCR3 = 5;
	//    
	TIM2->CCMR2 = TIM_CCMR2_OC3M_2 | TIM_CCMR2_OC3M_1 | TIM_CCMR2_OC3PE;
	//   
	TIM2->CCER = TIM_CCER_CC3E;
	TIM2->BDTR = TIM_BDTR_MOE;
	//     
	TIM2->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;		
	return;
}

void T1_config(void)
{
	RCC->APB2ENR |=RCC_APB2ENR_TIM1EN; 

	//TIM1->PSC = 8-1; //    1
	TIM1->PSC = 16-1; 
	TIM1->ARR = 0xffff;
	
	TIM1->CCR1 = 1;
	
	TIM1->CCMR1 = TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1PE;
	TIM1->CCER = TIM_CCER_CC1NE;
	TIM1->BDTR = TIM_BDTR_MOE;

	TIM1->DIER |= TIM_DIER_UIE;	
	TIM1->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;	

	
	NVIC_SetPriority(TIM1_UP_IRQn  , 2);
	NVIC_EnableIRQ(TIM1_UP_IRQn );
	
	return;
}
void RTC_conf (void)
{
	RCC->APB1ENR |= RCC_APB1ENR_PWREN ;
//	RCC->APB1ENR |= RCC_APB1ENR_BKPEN;

	PWR->CR |= PWR_CR_DBP;		  /*!< Disable Backup Domain write protection */

	RCC->BDCR|= RCC_BDCR_RTCEN;	   /*!< RTC clock enable */

	RCC->BDCR |= RCC_BDCR_BDRST;   /*!< Backup domain software reset  */
	RCC->BDCR &= ~RCC_BDCR_BDRST;

	RCC->BDCR |= RCC_BDCR_RTCEN | RCC_BDCR_RTCSEL_LSI;		 /*!< LSI oscillator clock used as RTC clock */

	RTC->CRL |= RTC_CRL_CNF;	   /*!<Configuration Flag */
//	RTC->PRLL = 0x7FFF;
	RTC->PRLL = 0x9c3f;

	RTC->CNTH = 0;
	RTC->CNTL = 0;
	RTC->CRL &= ~RTC_CRL_CNF;

	RTC->CRH|=RTC_CRH_SECIE;   /*!<Second Interrupt Enable */

	RCC->CSR |= RCC_CSR_LSION;
	while ((RCC->CSR & RCC_CSR_LSION) != RCC_CSR_LSION){}

	return;
}
void RTC_refr_par (void)
{
	RTC->CRL |= RTC_CRL_CNF;	   /*!<Configuration Flag */
	RTC->PRLL = 0xa40f;
	RTC->CNTH = 0;
	RTC->CNTL = 0;
	RTC->CRL &= ~RTC_CRL_CNF;
	RTC->CRH|=RTC_CRH_SECIE;   /*!<Second Interrupt Enable */
	return;
}

void power_save_mode (void)
{

	
 RCC->APB1ENR |= RCC_APB1ENR_PWREN;//??? ???????????? PWR
	SCB->SCR |= SCB_SCR_SLEEPDEEP; //??? M3 ????????? sleepdeep
	PWR->CR |= PWR_CR_PDDS;//???????? ????? Power Down Deepsleep
	PWR->CR |= PWR_CR_CWUF ; //??????? wakeup flag
	PWR->CSR |= PWR_CSR_EWUP; //????????? ??????, ?? ???? ??????????? ?? ????????? ?????? ?? ?0
	__wfi();  //??????
	
	
	return;
}

__asm void wfe (void)
{
	WFE
}
__asm void wfi (void)
{
	WFI
}

void adc_init (void)
{
	//     
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN;                //  GPIOA
	
	//RCC->CFGR |= RCC_CFGR_ADCPRE; 
	//RCC->CFGR |= RCC_CFGR_ADCPRE_DIV8;
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN;
	//ADC1->JSQR=0;
	
	//     
	RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;                //  GPIOB
	GPIOB->CRL  &= ~(GPIO_CRL_MODE1 | GPIO_CRL_CNF1);  //GPIOB.1 -  9
	//     
	ADC1->JSQR   =   0;                                //    1 
	ADC1->JSQR  |=   9<<15;                            // 1 -  9
	//  
	ADC1->CR1    =   0;                                //   
	ADC1->CR2    =   0;                                //   
	ADC1->CR2   |=   7<<12;                            //   - JSWSTART 
	ADC1->CR2   |=   ADC_CR2_JEXTTRIG;                 //  
	 
	//    
	ADC1->CR2   |=   ADC_CR2_ADON;                     // 
	ADC1->CR2   |=   ADC_CR2_RSTCAL;                   //  
	//while(!(ADC1->CR2 & ADC_CR2_RSTCAL)){};            //  
	ADC1->CR2   |=   ADC_CR2_CAL;                      //  
	while(!(ADC1->CR2 & ADC_CR2_CAL)){};               //  
	 
	ADC1->CR2   |=   ADC_CR2_JSWSTART;                 //  .

	return;
}

void USART1_Init(void)
{
  // 
  RCC->APB2ENR |=   RCC_APB2ENR_IOPAEN;                // GPIO
  RCC->APB2ENR |=   RCC_APB2ENR_AFIOEN;                //   GPIO
  RCC->APB2ENR |=   RCC_APB2ENR_USART1EN;              // USART1
  // PORTA.9  TX; PORTA.10  RX 
  GPIOA->CRH   &= ~(GPIO_CRH_MODE9 | GPIO_CRH_CNF9);   // MODE  CNF
  GPIOA->CRH   |=   GPIO_CRH_MODE9 | GPIO_CRH_CNF9_1;  //    -, 50MHz
  GPIOA->CRH   &= ~(GPIO_CRH_MODE10 | GPIO_CRH_CNF10); // MODE  CNF
  GPIOA->CRH   |=   GPIO_CRH_CNF10_0;                  //,  
  //  
  USART1->BRR   =   0x0341;                            //C  9600 
	
  USART1->CR1  &=  ~USART_CR1_M;                       //8  
  USART1->CR2  &=  ~USART_CR2_STOP;                    // -: 1
  // 
  USART1->CR1  |=   USART_CR1_UE;                      //  USART1
  USART1->CR1  |=   USART_CR1_TE;                      // 
  USART1->CR1  |=   USART_CR1_RE;                      // 
}
 
//********************************************************************************
//Function: USART1 - ???????? ?????                                             //
//Argument: ???????????? ????                                                   //
//********************************************************************************
void USART1_SendData(unsigned char data)
{
  USART1->DR  =  data;                                //????????? ??????? ????????
  while((USART1->SR & USART_SR_TC)==0) {}             //???????? ???????? ?????
  USART1->SR &=  ~USART_SR_TC;                        //???????? ????
		return;
}

//********************************************************************************
//Function:   USART2                                         //
//          9600 ; 8  ; 2 -                                 //
//********************************************************************************
void USART2_Init(void)
{
  // 
  RCC->APB2ENR |=   RCC_APB2ENR_IOPAEN;                // GPIO
  RCC->APB2ENR |=   RCC_APB2ENR_AFIOEN;                //   GPIO
  RCC->APB1ENR |=   RCC_APB1ENR_USART2EN;              // USART2
  // PORTA.2  TX; PORTA.3  RX 
	/*
  GPIOA->CRL   &= ~(GPIO_CRL_MODE2 | GPIO_CRL_CNF2);   // MODE  CNF
  GPIOA->CRL   |=   GPIO_CRL_MODE2 | GPIO_CRL_CNF2_1;  //    -, 50MHz
  GPIOA->CRL   &= ~(GPIO_CRL_MODE3 | GPIO_CRL_CNF3);   // MODE  CNF
  GPIOA->CRL   |=   GPIO_CRL_CNF3_0;                   //,  
	*/
  //  
 // USART2->BRR   =   0x0341;                            //C  9600 
  USART2->BRR   =   0x0D05;                            //C  2400 
	//USART2->BRR   =   0x0683;                            //C  4800 
//	USART2->BRR   =   0x008B;                            //C  57600 
  USART2->CR1  &=  ~USART_CR1_M;                       //8  
  USART2->CR2  &=  ~USART_CR2_STOP;                    //  -
  USART2->CR2  |=   USART_CR2_STOP_0;                  // -: 2
  // 
  USART2->CR1  |=   USART_CR1_UE;                      //  USART2
  USART2->CR1  |=   USART_CR1_TE;                      // 
  USART2->CR1  |=   USART_CR1_RE;                      // 
}
//********************************************************************************
//Function: USART2 -                                               //
//Argument:                                                     //
//********************************************************************************
void USART2_SendData(unsigned char data)
{
  USART2->DR  =  data;                                //  
  while((USART2->SR & USART_SR_TC)==0) {}             //  
  USART2->SR &=  ~USART_SR_TC;                        // 
}

void SPI1_init (void)
{
	//AFIO->MAPR |=AFIO_MAPR_SPI1_REMAP ;
	
	//  MOSI PA7:    , 50 MHz
	GPIOA->CRL   |=  GPIO_CRL_MODE7;    //
  GPIOA->CRL   &= ~GPIO_CRL_CNF7;     //
  GPIOA->CRL   |=  GPIO_CRL_CNF7_1;   //
 
	// MISO PA6:     , 50MHz
  GPIOA->CRL   &= ~GPIO_CRL_MODE6;    //
  GPIOA->CRL   &= ~GPIO_CRL_CNF6;     //
  GPIOA->CRL   |=  GPIO_CRL_CNF6_1;   //
 // GPIOA->BSRR   =  GPIO_BSRR_BS6;     //
 
  // SCK PA5:     , 50MHz
  GPIOA->CRL   |=  GPIO_CRL_MODE5;    //
  GPIOA->CRL   &= ~GPIO_CRL_CNF5;     //
  GPIOA->CRL   |=  GPIO_CRL_CNF5_1;   //
 
  // NSS PA4:     , 50MHz
 // GPIOA->CRL   |=  GPIO_CRL_MODE4;    //
 // GPIOA->CRL   &= ~GPIO_CRL_CNF4;     //
  //GPIOA->CRL   |=  GPIO_CRL_CNF4_1;   //
	GPIOA->CRL |= GPIO_CRL_MODE4;  
	GPIOA->CRL &=~GPIO_CRL_CNF4;
	GPIOA->BSRR|= GPIO_BSRR_BS4;
 
  //  SPI
  RCC->APB2ENR |= RCC_APB2ENR_SPI1EN; // 
  SPI1->CR2     = 0x0000;             //
  SPI1->CR1     = SPI_CR1_MSTR;       // -  
	
	SPI1->CR1    &= ~SPI_CR1_CPHA;
	SPI1->CR1    &= ~SPI_CR1_CPOL; 
	SPI1->CR1    &= ~SPI_CR1_RXONLY;		//  
	SPI1->CR1    &= ~SPI_CR1_DFF;				//   8 
	
  SPI1->CR1    |= SPI_CR1_BR;         //   
	
	/*
	SPI1->CR1 &= ~SPI_CR1_BR_0;
	SPI1->CR1 &= ~SPI_CR1_BR_1;
	SPI1->CR1 &= ~SPI_CR1_BR_2;
	*/
	
  SPI1->CR1    |= SPI_CR1_SSI;
  SPI1->CR1    |= SPI_CR1_SSM;				//  NSS
  SPI1->CR1    |= SPI_CR1_SPE;        //  SPI
	
	return;
}

uint8_t spi_send (uint8_t data)
{ 
  while (!(SPI1->SR & SPI_SR_TXE));      //  
  SPI1->DR = data;                       //   
  while (!(SPI1->SR & SPI_SR_RXNE));     //  
  return (SPI1->DR);		        				 //  
}

uint8_t spi_read (void)
{ 
  return spi_send(0xff);		  //  
}

u16 SPI_ReadByte(u16 byte)
{
	//while (!(SPI1->SR & 2));
	while (!(SPI1->SR & SPI_SR_TXE));
	SPI1->DR=byte;
	//while (!(SPI1->SR & 1));
	while (!(SPI1->SR & SPI_SR_RXNE));
	return SPI1->DR;
}
