#include "stm32F10x.h"

#define volt_33	3300


#define left_key			GPIO_IDR_IDR7	  // PORTB
#define right_key			GPIO_IDR_IDR15	  // PORTA
#define center_key		GPIO_IDR_IDR0	  // PORTA


//     9 
//     3.3 
#define LCD_on  			/*GPIOA->CRL |= GPIO_CRL_MODE5;*/ GPIOB->BSRR|= GPIO_BSRR_BR5;
#define LCD_off  			/*GPIOA->CRL &= ~GPIO_CRL_MODE5;*/ GPIOB->BSRR|= GPIO_BSRR_BS5;

//     
#define HV_on  				GPIOB->BSRR|= GPIO_BSRR_BR0;
#define HV_off  			GPIOB->BSRR|= GPIO_BSRR_BS0;

#define snd_pin_en	GPIOB->CRL &= ~GPIO_CRL_CNF6;GPIOB->CRL |=  GPIO_CRL_CNF6_1;
#define snd_pin_dis		GPIOB->CRL &= ~GPIO_CRL_CNF6;GPIOB->BSRR =  GPIO_BSRR_BR6;  

/*
#define capt_start 			TIM2->DIER=0; TIM2->DIER |= TIM_DIER_CC1IE; TIM2->CR1|= TIM_CR1_CEN ;	
#define capt_halt 			TIM2->DIER =0; TIM2->CR1 = 0;

#define PWM_halt	TIM1->CR1 &= ~TIM_CR1_CEN;
#define PWM_start	TIM1->CR1 |= TIM_CR1_CEN;
*/

//#define contact_n_phase	28
//#define contact_t_phase	10
#define bat_val_min		2100


void pll_init (void);
void pio_config (void);
void T1_config (void);
void T2_capt_init(void);
void T3_config (void);
void T4_config (void);
void sys_tick_config (void);

void T2_config (void);

void RTC_conf (void);
void RTC_refr_par (void);

unsigned int play_snd (unsigned int fr_hz, unsigned int time_ms);

void power_save_mode (void);
__asm void wfi (void);
__asm void wfe (void);

void adc_init (void);

void USART1_Init(void);
void USART1_SendData(unsigned char data);
void UART1_send_val(unsigned int data);
void USART2_SendData(unsigned char data);
void USART2_Init(void);

void SPI1_init (void);
uint8_t spi_send (uint8_t data);



