#include "cpu_conf.h"
#include "common.h"	
#include "tools.h"
#include "i2c.h"
#include "tic120.h"
#include "NRF.h"
#include "mirf.h"
#include "nRF24L01.h"

unsigned char sec=0,min=0;
unsigned char k_menu=0,k_sel=0;
unsigned int k_time_out=0;
unsigned int mag_val=1,fr_val=60;
unsigned int mag_tmp=1,fr_tmp=60;
volatile unsigned int i_a=0,i_f=0,i_int=0;
unsigned char FM_mode=0,AM_mode=0,INT_mode=0;
unsigned int sleep_c=0;
unsigned char fr_points=0;
volatile unsigned int i_snd=0,snd_time=0;
unsigned char i_key=0,k_sleep=0;
unsigned char sel_to_energy=0,k_menu_sav=0;

unsigned char n_phase,n_phase_val=40;
unsigned char	cont_det=0,cont_det_tmp=0;
unsigned int T_phase_1,T_phase_2, T_phase_1_tmp,T_phase_2_tmp,T_phase_1_stor;
unsigned int reaction_1=0,threshold1_0=0,threshold2_0=0,T_phase_1_zero=0,T_phase_1_dose=0, dose_count=0;

unsigned char sec_val=0,speed=0,speed_tmp=0,DOSE=0,ZERO=0,dose_progress=0,dose_progress_tmp=0; 

unsigned char key_r_was_pressed=0,key_r_was_pressed_tmp=0;
unsigned char key_l_was_pressed=0,key_l_was_pressed_tmp=0;
unsigned char key_c_was_pressed=0,key_c_was_pressed_tmp=0;

unsigned char cursor_val=0;
unsigned char mode=0;

unsigned char diagn_mode,diagn_jump=0;

unsigned int bat_val=4200,bat_val_tmp=4200;
unsigned char bat_is_low=0;
unsigned char vol=1;

unsigned char contact_n_phase=	28;
unsigned int contact_t_phase=	10;


unsigned int adr_sn_val;

unsigned char send_arr[6];
unsigned char tx_len=0;
unsigned int crc16=0;
unsigned char i_tmp=0;

unsigned char tim_en=0;
unsigned char key_hold=0;

unsigned char status=0;


uint16_t VirtAddVarTab[20]={
0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13
};
uint16_t sw_cnt_p=0,FM_mode_p=0,AM_mode_p=0,fr_val_p=0,vol_p=0,intens_cond_p=0,gap_cond_p,autooff_t_p,contact_n_phase_p,contact_t_phase_p,fr_points_p=0;


unsigned char sta=0;
uint8_t nrf_buf[5]={0x01,0x02,0x03,0x04,0x05};
uint8_t buf[5];

uint8_t tx_addr[5]={0x01,0x02,0x03,0x04,0x05};
//uint8_t rx_addr[5]={0x02,0x02,0x03,0x04,0x05};
uint8_t rx_addr[5]={0x02,0x02,0x03,0x04,0x05};


void bat_ind (unsigned int bat_val);
void timer_ind (unsigned int sec_val);
void contact_ind (unsigned char cont_det);
void cursor_mov (unsigned char cursor_val,unsigned char mode);

void mode_ind (unsigned char mode);


void menu_minus(void);
void menu_plus(void);
void AM_modulation (unsigned char AM_mode);
void FM_modulation (unsigned char FM_mode);
void INT_modulation (unsigned char INT_mode);
void intens_set (unsigned char intens_cond);
void gap_set (unsigned char gap_cond);


void start_mode_ind(unsigned char diagn_mode,unsigned char AM_mode,unsigned char FM_mode);

void start_screen_ind(void);
void main_screen_ind (unsigned char k_menu, unsigned int mag_val);
void cursor_move (unsigned char k_menu);
void dose_progerss_fill(unsigned char val);
void react_progerss_fill(unsigned char val);
void react_progerss(unsigned char val);

void am_val_ind (unsigned char am_mode, unsigned char inv);
void fm_val_ind (unsigned char fm_mode, unsigned char inv);
void diag_val_ind (unsigned char diag_mode_val);
void gap_val_ind (unsigned char gap_val,unsigned char inv);
void intens_val_ind (unsigned char intens_val, unsigned char inv);
void get_int_cond (unsigned char intens_tmp);

void start_menu_ind (void);
void start_menu_sel (unsigned char start_menu_item, unsigned char up_dn);
void start_menu_jumping (unsigned char start_menu_item);
void manual_menu_sel (unsigned char manual_menu_item, unsigned char up_dn);
void manual_menu_ind(void);

void presets_menu_sel (unsigned char presets_menu_item, unsigned char up_dn);
void presets_menu_jumping (unsigned char presets_menu_item);
void presets_menu_ind(void);

void contact_ind (unsigned char cont_det);
void diagn_menu_ind (void);

void config_menu_ind (void);
void config_menu_sel (unsigned char config_menu_item, unsigned char up_dn);
void volume_val_ind (unsigned char val,unsigned char inv);
void autooff_val_ind (unsigned char val,unsigned char inv);

void send_mode (unsigned char mode);

uint16_t EE_Init(void);
uint16_t EE_ReadVariable(uint16_t VirtAddress, uint16_t* Data);
uint16_t EE_WriteVariable(uint16_t VirtAddress, uint16_t Data);

#define up		0
#define	down	1
#define	time_out_val	250	//    

#define lang		1

#if	(lang==0) // eng
	#define logo_str1						sh1306_put_str_mid_new(10, 0, " Remote");
	#define logo_str2						sh1306_put_str_mid_new(5, 2, " Electrode");
	#define logo_str3						sh1306_put_str_mid_new(0, 4, " Controller");
	#define logo_str4						sh1306_put_str_mid_new(0, 6, " 30 09 16");


	#define par_val_x			65
	#define par_nm_x			30
	#define par_nm_big_x	10

	#define par_val_y		2

	#define man_menu_item0						sh1306_put_str_mid_new(par_nm_x+2, 2, "En");			sh1306_3_dig_mid_new(par_val_x+2,2, mag_val);
	#define man_menu_big_item0				sh1106_put_str_big_new(2, 2, "En"); man_menu_big_item0_val;
	#define man_menu_big_item0_val		sh1106_3_dig_big_new(55,2, mag_val);

	#define mode_big_item0						sh1106_put_str_big_new(par_nm_big_x+6, 4, "15Hz");					
	#define mode_big_item1						sh1106_put_str_big_new(par_nm_big_x+6, 4, "50Hz");				
	#define mode_big_item2						sh1106_put_str_big_new(par_nm_big_x-6, 4, "150Hz");					
	#define mode_big_item3						sh1106_put_str_big_new(par_nm_big_x, 4,	  "*AM*");			
	#define mode_big_item4						sh1106_put_str_big_new(par_nm_big_x, 4,   "*FM*");			

	#define man_menu_item0_inv				sh1306_put_str_mid_new_inv(par_nm_x+2, 2, "En");	man_menu_item0_val_inv;
	#define man_menu_item0_val_inv		sh1306_3_dig_mid_new_inv(par_val_x+2,2, mag_val);

	#define mode_item0								sh1306_put_str_mid_new(par_nm_x, 6, " 15Hz ");	
	#define mode_item1								sh1306_put_str_mid_new(par_nm_x, 6, " 50Hz ");	
	#define mode_item2								sh1306_put_str_mid_new(par_nm_x, 6, " 150Hz");	
	#define mode_item3								sh1306_put_str_mid_new(par_nm_x, 6, " *AM* ");	
	#define mode_item4								sh1306_put_str_mid_new(par_nm_x, 6, " *FM* ");	
						
#elif	(lang	==1) // rus
/*
	#define logo_str1						sh1306_put_str_mid_new(10, 0, "  ");
	#define logo_str2						sh1306_put_str_mid_new(15, 2, "");
	#define logo_str3						sh1306_put_str_mid_new(18, 4, "");
	#define logo_str4						sh1306_put_str_mid_new(0, 6, " 20 10 16");
	*/
	#define logo_str1						sh1306_put_str_mid_new(10, 0, "  ");
	#define logo_str2						sh1306_put_str_mid_new(15, 2, "-");
	#define logo_str3						sh1306_put_str_mid_new(18, 4, "");
	#define logo_str4						sh1306_put_str_mid_new(0, 6, " 20 10 16");

	#define par_val_x			65
	#define par_nm_x			30
	#define par_nm_big_x	10

	#define par_val_y		2

	#define man_menu_item0						sh1306_put_str_mid_new(par_nm_x+2, 2, "");			sh1306_3_dig_mid_new(par_val_x+2,2, mag_val);
	#define man_menu_big_item0				sh1106_put_str_big_new(2, 2, ""); man_menu_big_item0_val;
	#define man_menu_big_item0_val		sh1106_3_dig_big_new(55,2, mag_val);

	#define mode_big_item0						sh1106_put_str_big_new(par_nm_big_x+6, 4, "15");					
	#define mode_big_item1						sh1106_put_str_big_new(par_nm_big_x+6, 4, "50");				
	#define mode_big_item2						sh1106_put_str_big_new(par_nm_big_x-6, 4, "150");					
	#define mode_big_item3						sh1106_put_str_big_new(par_nm_big_x, 4,	  "**");			
	#define mode_big_item4						sh1106_put_str_big_new(par_nm_big_x, 4,   "**");			

	#define man_menu_item0_inv				sh1306_put_str_mid_new_inv(par_nm_x+2, 2, "");	man_menu_item0_val_inv;
	#define man_menu_item0_val_inv		sh1306_3_dig_mid_new_inv(par_val_x+2,2, mag_val);

	#define mode_item0								sh1306_put_str_mid_new(par_nm_x, 6, " 15 ");	
	#define mode_item1								sh1306_put_str_mid_new(par_nm_x, 6, " 50 ");	
	#define mode_item2								sh1306_put_str_mid_new(par_nm_x, 6, " 150");	
	#define mode_item3								sh1306_put_str_mid_new(par_nm_x, 6, " ** ");	
	#define mode_item4								sh1306_put_str_mid_new(par_nm_x, 6, " ** ");	
#endif


#define	start		0xaa
#define	adr_sn	0x0001

#define	mag			0xa1
#define	fr			0xa2
#define	am_m		0xa3
#define	fm_m		0xa4
#define	i_			0xa5
#define	suppl		0xa0

#define	suppl_off			//send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=suppl;	send_arr[4]=0xaa; send_arr[5]=0x55;
#define	mag_send(x)		//send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=mag;		send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	fr_send(x)		//send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=fr;		send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	amm_send(x)		//send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=am_m;	send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	fmm_send(x)		//send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=fm_m;	send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	int_send(x)		//send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=i_;		send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;

#define	send_mes	//tx_len=6;for(i_tmp=0;i_tmp<tx_len;i_tmp++){USART2_SendData(send_arr[i_tmp]);}
#define	send_crc	//tx_len=6;for(i_tmp=0;i_tmp<tx_len;i_tmp++){crc16=crc16+send_arr[i_tmp];}USART2_SendData((0xff00&crc16)>>8);USART2_SendData(0x00ff&crc16);

/*
#define	mag_send(x)		USART2_SendData(start);USART2_SendData((0xff00&adr_sn)>>8);USART2_SendData(0x00ff&adr_sn);USART2_SendData(mag);		USART2_SendData((0xff00&x)>>8);USART2_SendData(0x00ff&x);
#define	fr_send(x)		USART2_SendData(start);USART2_SendData((0xff00&adr_sn)>>8);USART2_SendData(0x00ff&adr_sn);USART2_SendData(fr);		USART2_SendData((0xff00&x)>>8);USART2_SendData(0x00ff&x);
#define	amm_send(x)		USART2_SendData(start);USART2_SendData((0xff00&adr_sn)>>8);USART2_SendData(0x00ff&adr_sn);USART2_SendData(am_m);	USART2_SendData((0xff00&x)>>8);USART2_SendData(0x00ff&x);
#define	fmm_send(x)		USART2_SendData(start);USART2_SendData((0xff00&adr_sn)>>8);USART2_SendData(0x00ff&adr_sn);USART2_SendData(fm_m);	USART2_SendData((0xff00&x)>>8);USART2_SendData(0x00ff&x);
#define	int_send(x)		USART2_SendData(start);USART2_SendData((0xff00&adr_sn)>>8);USART2_SendData(0x00ff&adr_sn);USART2_SendData(i_);		USART2_SendData((0xff00&x)>>8);USART2_SendData(0x00ff&x);

*/


#define	beep								if(vol==1){snd_time= play_snd (500, 150);}delay(25000);
#define	beep_lim						if(vol==1){snd_time= play_snd (1000, 150);}delay(4000);
#define	tick								if(vol==1){snd_time= play_snd (1000, 2);delay(40);}
#define	beep_point					if(vol==1){snd_time= play_snd (500, 150);}delay(25000);

#define	fr_max_val	500
#define	fr_min_val	16


void TIM1_UP_IRQHandler()
{
	TIM1->SR &= ~TIM_SR_UIF;	
	//PWM_halt;
	
	
	return;
}

void TIM3_IRQHandler() 
{
	
	TIM3->SR &= ~TIM_SR_UIF;	
	return;
}

void TIM4_IRQHandler() 
{	
	TIM4->SR &= ~TIM_SR_UIF;
	i_snd++;
	if(i_snd> snd_time)
	{		
		snd_pin_dis;
		i_snd=0;
		TIM4->DIER &= ~TIM_DIER_UIE; TIM4->CR1 &= ~TIM_CR1_CEN;TIM4->CNT=0;
	}
	return;
}

void SysTick_Handler()
{
	SysTick->CTRL&=~SysTick_CTRL_COUNTFLAG;
	
	
	return;
}

int main (void)
{
	pll_init ();
	pio_config ();
	
	//  
	FLASH_Unlock();
	//  
	EE_Init(); 
	
	LCD_on;HV_on;
	T4_config ();
	T2_config ();
	SPI1_init ();
	delay(2000);
	snd_pin_dis;
	sh1306_init ();
// LOGO
	logo_str1;logo_str2;logo_str3;logo_str4;
	
	if((PWR->CSR&PWR_CSR_SBF)==0){ goto strt;} //      

	if(keyA(center_key)==1){delay(20000);}
	else {LCD_off;HV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(20000);}
	else {LCD_off;HV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(20000);}
	else {LCD_off;HV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(20000);}
	else {LCD_off;HV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(20000);}
	else {LCD_off;HV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(20000);}
	else {LCD_off;HV_off;power_save_mode ();}
	
	strt:

	if(vol==1){snd_time= play_snd (1000, 255);}delay(4000);if(vol==1){snd_time= play_snd (500,255);}delay(4000);
	if(vol==1){snd_time= play_snd (1000, 255);}delay(4000);if(vol==1){snd_time= play_snd (500,255);}delay(4000);
	if(vol==1){snd_time= play_snd (1000, 255);}delay(4000);if(vol==1){snd_time= play_snd (500,255);}delay(4000);
	if(vol==1){snd_time= play_snd (1000, 255);}delay(4000);if(vol==1){snd_time= play_snd (500,255);}delay(4000);
	if(vol==1){snd_time= play_snd (1000, 255);}delay(4000);if(vol==1){snd_time= play_snd (500,255);}delay(4000);
	
	
	RTC_conf ();
	adc_init ();
	ADC1->CR2 |= ADC_CR2_JSWSTART;if((ADC1->SR & ADC_SR_JEOC) == ADC_SR_JEOC)	{	bat_val_tmp=2*(((ADC1->JDR1*volt_33)/4096))+50;}
	
	//USART2_Init();
	sys_tick_config();
	
	sh1306_clear_screen();

	bat_ind (bat_val);
	timer_ind (sec_val);
	
	cursor_val=0;
	mag_send(mag_val);send_mes;send_crc;
	
	mode=1;
	send_mode (mode);
	
	cursor_mov (cursor_val,mode);
//contact_ind (tim_en);	

	tim_en=1;

	sh1306_clear_screen();

	//SPI1_init ();
	

//	nrf_buf[5]=0x01,0x02,0x03,0x04,0x05;


	radio_init();

	while (!radio_start()) {_delay_ms(1000);}
  _delay_ms(2); 
  radio_assert_ce();
	

/* 
	// MIRF library
  //  mirf_init();
	// Wait for mirf to come up
	_delay_ms(500);	
	
	// Configure mirf
	//mirf_config();

	mirf_config_register(CONFIG, (1 << EN_CRC) | (1 << CRCO) | (1 << PRIM_RX)| (1 << PWR_UP));
	mirf_config_register(EN_RXADDR, (1 << ERX_P0));
	mirf_config_register(SETUP_AW, SETUP_AW_5BYTES_ADDRESS);
	mirf_config_register(SETUP_RETR, SETUP_RETR_DELAY_250MKS | SETUP_RETR_UP_TO_2_RETRANSMIT);
	mirf_config_register(RF_CH,1);
	mirf_config_register(RF_SETUP, RF_SETUP_1MBPS | RF_SETUP_0DBM);
	mirf_config_register(RX_PW_P0,5);
	mirf_config_register(CONFIG, (1 << EN_CRC) | (1 << CRCO) | (1 << PRIM_RX)| (1 << PWR_UP));

*/


	// reg value indication
	sh1306_2_hex_small(5,2, radio_readreg(CONFIG));
	sh1306_2_hex_small(5,3, radio_readreg(EN_RXADDR));
	sh1306_2_hex_small(5,4, radio_readreg(SETUP_AW));
	sh1306_2_hex_small(5,5, radio_readreg(SETUP_RETR));
	sh1306_2_hex_small(5,6, radio_readreg(RF_CH));
	sh1306_2_hex_small(5,7, radio_readreg(RF_SETUP));
	sh1306_2_hex_small(35,2, radio_readreg(RX_PW_P0));

	radio_read_buf(TX_ADDR, buf, 5); 
	//radio_read_buf(RX_ADDR_P0, buf, 5); 
	//radio_read_buf(RX_ADDR_P1, buf, 5); 
	sh1306_2_hex_small(35,3, buf[0]);
	sh1306_2_hex_small(35,4, buf[1]);
	sh1306_2_hex_small(35,5, buf[2]);
	sh1306_2_hex_small(35,6, buf[3]);
	sh1306_2_hex_small(35,7, buf[4]);



_delay_ms(500);



	while (1)
	{

	nrf_buf[0]++;
	nrf_buf[1]--;
	nrf_buf[2]++;
	nrf_buf[3]--;
	//nrf_buf[4]++;
	//nrf_buf[5]--;
	//nrf_buf[6]++;
	//nrf_buf[7]--;
		
   sta=send_data(nrf_buf,4);
	//mirf_send(nrf_buf,4);

  sh1306_2_hex_small(90,6, sta);
	sh1306_2_hex_small(90,7, radio_readreg(STATUS));


/*
	radio_read_buf(W_TX_PAYLOAD, buf, 5); 
	sh1306_2_hex_small(35,3, buf[0]);
	sh1306_2_hex_small(35,4, buf[1]);
	sh1306_2_hex_small(35,5, buf[2]);
	sh1306_2_hex_small(35,6, buf[3]);
	sh1306_2_hex_small(35,7, buf[4]);
*/
 _delay_ms(100);

	//check_radio();

/*	

//	while (!mirf_data_ready());
mirf_data_ready();
  mirf_get_data(buf);

	sh1306_2_hex_small(90,6,buf[0]);
		


*/




		if(keyA(right_key)==0)
		{
			key_r_was_pressed_tmp=1;
			k_time_out=0;
			if (i_key<=24)i_key++;
			else
			{
				if(cursor_val==0)
				{
					mag_val++;if(mag_val>500){mag_val=500;beep_lim;}else{tick;}
					man_menu_big_item0_val;
					mag_send(mag_val);send_mes;send_crc;
				}
				
				if(cursor_val==1)
				{


				}
			}
			
			
			delay(500);
		}
		
		if(keyA(right_key)==1)//
		{	
			key_r_was_pressed=0;
			if (key_r_was_pressed_tmp!=key_r_was_pressed)
			{
				key_r_was_pressed=key_r_was_pressed_tmp;
				if(cursor_val==0)
				{
					mag_val++;if(mag_val>500){mag_val=500;beep_lim;}else{tick;}
					man_menu_big_item0_val;
					mag_send(mag_val);send_mes;send_crc;
				}
				if(cursor_val==1)
				{
					tim_en++;if(tim_en>1){tim_en=0;}
					if(tim_en==0){beep_point;}
					if(tim_en==1){beep_point;beep_point;}
					//contact_ind (tim_en);

				}
			}
			key_r_was_pressed_tmp=0;
		}
		
		if(keyB(left_key)==0)
		{
			key_l_was_pressed_tmp=1;
			k_time_out=0;
			if (i_key<=24)i_key++;
			else
			{
				if(cursor_val==0)
				{
					mag_val--;if(mag_val<1){mag_val=1;beep_lim;}else{tick;}
					man_menu_big_item0_val
					mag_send(mag_val);send_mes;send_crc;
				}
				if(cursor_val==1)
				{
					
					
				}
			}
			delay(500);
		}
		if(keyB(left_key)==1)//
		{	
			key_l_was_pressed=0;
			if (key_l_was_pressed_tmp!=key_l_was_pressed)
			{
				key_l_was_pressed=key_l_was_pressed_tmp;
				if(cursor_val==0)
				{
					mag_val--;if(mag_val<1){mag_val=1;beep_lim;}else{tick;}
					man_menu_big_item0_val;
					mag_send(mag_val);send_mes;send_crc;
				}
				if(cursor_val==1)
				{
					sec_val=0;beep_lim;

				}
			}
			key_l_was_pressed_tmp=0;
		}
		
		
		if(keyA(center_key)!=0)
		{
			key_c_was_pressed_tmp=1;
			k_time_out=0;
			sleep_c++;
			
		}
		if(keyA(center_key)==0)//
		{	
			key_c_was_pressed=0;
			if (key_c_was_pressed_tmp!=key_c_was_pressed)
			{
				key_c_was_pressed=key_c_was_pressed_tmp;
				
				if(cursor_val==0)
				{
					cursor_val=1;
					cursor_mov (cursor_val,mode);
					goto m;
				}
				if(cursor_val!=0)
				{
					mode++;
					if(mode>4){mode=0;}
					mode_ind (mode);
					send_mode (mode);
				}
				beep_point;
			}
			m:
			key_c_was_pressed_tmp=0;
		}
		
	
		if ((keyA(center_key)==0)&(keyA(right_key)==1)&(keyB(left_key)==1))
		{
			key_r_was_pressed=0;key_l_was_pressed=0;key_c_was_pressed=0;
			i_key=0;key_hold=0;sleep_c=0;
			
		}
		if(cursor_val!=0)
		{
			k_time_out++;
			if(k_time_out>time_out_val)
			{
				cursor_val=0;
				cursor_mov (cursor_val,mode);
			}
		}
		
		if (sleep_c>60000)
		{
			RTC->CRH&=~RTC_CRH_SECIE; 
			SysTick->CTRL&=~SysTick_CTRL_ENABLE;
						
			EE_WriteVariable(VirtAddVarTab[0x0a],diagn_mode);
			EE_WriteVariable(VirtAddVarTab[0x0b],AM_mode);
			EE_WriteVariable(VirtAddVarTab[0x0c],FM_mode);
			EE_WriteVariable(VirtAddVarTab[0x0d],fr_points);
//			EE_WriteVariable(VirtAddVarTab[0x11],intens_cond);
	//		EE_WriteVariable(VirtAddVarTab[0x10],gap_cond);
			EE_WriteVariable(VirtAddVarTab[0x0e],vol);
			if(vol==1){snd_time= play_snd (500, 255);}delay(4000);if(vol==1){snd_time= play_snd (1000,255);}delay(4000);
			if(vol==1){snd_time= play_snd (500, 255);}delay(4000);if(vol==1){snd_time= play_snd (1000,255);}delay(4000);
			if(vol==1){snd_time= play_snd (500, 255);}delay(4000);if(vol==1){snd_time= play_snd (1000,255);}delay(4000);
			if(vol==1){snd_time= play_snd (500, 255);}delay(4000);if(vol==1){snd_time= play_snd (1000,255);}delay(4000);
			if(vol==1){snd_time= play_snd (500, 255);}delay(4000);if(vol==1){snd_time= play_snd (1000,255);}delay(4000);
			
			suppl_off;send_mes;send_crc;
			delay(9000);delay(9000);
			sh1106_rst_low;
			LCD_off;HV_off;power_save_mode ();
		}
		
		
		if((RTC->CRL&RTC_CRL_SECF)==RTC_CRL_SECF)
	 	{	
			RTC->CRL&= ~RTC_CRL_SECF;
			
			if(tim_en==1)
			{
				sec_val++;timer_ind (sec_val);
				if(sec_val==60){beep_point;}
			}
			
			sec++;if (sec>60){sec=0;min++;}
			if(sec%4==3)
			{
				ADC1->CR2 |= ADC_CR2_JSWSTART;
				if((ADC1->SR & ADC_SR_JEOC) == ADC_SR_JEOC)	{	bat_val_tmp=2*(((ADC1->JDR1*volt_33)/4096))+50;}
				//bat_ind (bat_val_tmp);
				if(bat_val_tmp!=bat_val)
				{
					bat_val=bat_val_tmp;
					bat_ind (bat_val);
				}
			}
			
		}
	}	
}




void bat_ind (unsigned int bat_val)
{
	if (bat_val<3300) {sh1306_WriteChar_mid_new(110, 0, 'Z'+1);}
	if ((bat_val>=3300)&(bat_val<3600)){sh1306_WriteChar_mid_new(110, 0, 'Z'+2);}
	if ((bat_val>=3600)&(bat_val<3900)){sh1306_WriteChar_mid_new(110, 0, 'Z'+3);}
	if (bat_val>=3900) {sh1306_WriteChar_mid_new(110, 0, 'Z'+4);}
	return;
}

void mode_ind (unsigned char mode)
{
	sh1306_clear_page (4);sh1306_clear_page (5);
	sh1306_clear_page (6);sh1306_clear_page (7);
	if(mode==0){mode_big_item0;}
	if(mode==1){mode_big_item1;}
	if(mode==2){mode_big_item2;}
	if(mode==3){mode_big_item3;}
	if(mode==4){mode_big_item4;}
}

void timer_ind (unsigned int sec_val)
{
	sh1306_3_timer_mid_new(0,0, sec_val);
//	sh1306_3_timer_mid_new(42,6, 15*60-sec_val);
	return;
}

void contact_ind (unsigned char cont_det)
{
	if (cont_det==0){sh1306_WriteChar_mid_new(78, 0, 0x5c); }//  
	if (cont_det==1){sh1306_WriteChar_mid_new(78, 0, 0x5b);}
	return;
}
void cursor_mov (unsigned char cursor_val,unsigned char mode)
{
	sh1306_clear_page (2);
	sh1306_clear_page (3);
	sh1306_clear_page (4);
	sh1306_clear_page (5);
	sh1306_clear_page (6);
	sh1306_clear_page (7);	
	if(cursor_val==0)// move to energy
	{
		man_menu_big_item0;
		if(mode==0){mode_item0;}
		if(mode==1){mode_item1}
		if(mode==2){mode_item2;}
		if(mode==3){mode_item3;}
		if(mode==4){mode_item4;}	
	}
	if(cursor_val==1)
	{
		man_menu_item0;
		
		if(mode==0){mode_big_item0;}
		if(mode==1){mode_big_item1;}
		if(mode==2){mode_big_item2;}
		if(mode==3){mode_big_item3;}
		if(mode==4){mode_big_item4;}
	}
	return;
}

void send_mode (unsigned char mode)
{
	if(mode==0)
	{
		fr_val=15;fr_send(fr_val+1);send_mes;send_crc;
		AM_mode=0;amm_send(AM_mode);send_mes;send_crc;
		FM_mode=0;fmm_send(FM_mode);send_mes;send_crc;
	}
	if(mode==1)
	{
		fr_val=50;fr_send(fr_val);send_mes;send_crc;
		AM_mode=0;amm_send(AM_mode);send_mes;send_crc;
		FM_mode=0;fmm_send(FM_mode);send_mes;send_crc;
	}
	if(mode==2)
	{
		fr_val=150;fr_send(fr_val);send_mes;send_crc;
		AM_mode=0;amm_send(AM_mode);send_mes;send_crc;
		FM_mode=0;fmm_send(FM_mode);send_mes;send_crc;
	}
	if(mode==3)
	{
		fr_val=50;fr_send(fr_val);send_mes;send_crc;
		AM_mode=1;amm_send(AM_mode);send_mes;send_crc;
		FM_mode=0;fmm_send(FM_mode);send_mes;send_crc;
	}
	if(mode==4)
	{
		fr_val=15;fr_send(fr_val);send_mes;send_crc;
		AM_mode=0;amm_send(AM_mode);send_mes;send_crc;
		FM_mode=1;fmm_send(FM_mode);send_mes;send_crc;
	}
	return;
}

void am_val_ind (unsigned char am_mode, unsigned char inv)
{
	if(inv==0)
	{
		sh1306_clear_page_sh (par_val_x,4,40);sh1306_clear_page_sh (par_val_x,5,40);
		if(am_mode==0){sh1306_put_str_mid_new(par_val_x, 4, "OFF");}
		if(am_mode==1){sh1306_put_str_mid_new(par_val_x, 4, "AM1");}
		if(am_mode==2){sh1306_put_str_mid_new(par_val_x, 4, "AM2");}
		if(am_mode==3){sh1306_put_str_mid_new(par_val_x, 4, "AM3");}
		if(am_mode==4){sh1306_put_str_mid_new(par_val_x, 4, "AMV");}
	}
	if(inv==1)
	{
		sh1306_fill_page_sh (par_val_x,4,40);sh1306_fill_page_sh (par_val_x,5,40);
		if(am_mode==0){sh1306_put_str_mid_new_inv(par_val_x, 4, "OFF");}
		if(am_mode==1){sh1306_put_str_mid_new_inv(par_val_x, 4, "AM1");}
		if(am_mode==2){sh1306_put_str_mid_new_inv(par_val_x, 4, "AM2");}
		if(am_mode==3){sh1306_put_str_mid_new_inv(par_val_x, 4, "AM3");}
		if(am_mode==4){sh1306_put_str_mid_new_inv(par_val_x, 4, "AMV");}
	}
}
void fm_val_ind (unsigned char fm_mode, unsigned char inv)
{
	if(inv==0)
	{
		sh1306_clear_page_sh (par_val_x,4,40);sh1306_clear_page_sh (par_val_x,5,40);
		if(fm_mode==0){sh1306_put_str_mid_new(par_val_x, 4, "OFF");}
		if(fm_mode==1){sh1306_put_str_mid_new(par_val_x, 4, "FM1");}
		if(fm_mode==2){sh1306_put_str_mid_new(par_val_x, 4, "FM2");}
		if(fm_mode==3){sh1306_put_str_mid_new(par_val_x, 4, "Bio");}	
	}
	if(inv==1)
	{
		sh1306_fill_page_sh (par_val_x,4,40);sh1306_fill_page_sh (par_val_x,5,40);
		if(fm_mode==0){sh1306_put_str_mid_new_inv(par_val_x, 4, "OFF");}
		if(fm_mode==1){sh1306_put_str_mid_new_inv(par_val_x, 4, "FM1");}
		if(fm_mode==2){sh1306_put_str_mid_new_inv(par_val_x, 4, "FM2");}
		if(fm_mode==3){sh1306_put_str_mid_new_inv(par_val_x, 4, "Bio");}	
	}
}
